﻿using System;
using System.IO;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace csv23ds
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
            label1.Text = "ver.0.03";
        }

        int ix, iy = 0;
        float xm, xn, ym, yn;
        float[] x = new float[255];
        float[] y = new float[255];
        float[,] z = new float[255, 255];

        private static void AddText(FileStream fs, string value)
        {
            byte[] info = new UTF8Encoding(true).GetBytes(value);
            fs.Write(info, 0, info.Length);
        }

        private void button1_Click(object sender, EventArgs e)
        {
            char[] cs = new char[] { ',' };
            int i, j;
            string line;
            string[] split = null;
            float dx, dy, s;
            xm = ym = float.MaxValue;
            xn = yn = float.MinValue;
            openFileDialog1.ShowDialog();
            StreamReader sr = new StreamReader(openFileDialog1.FileName);
            line = sr.ReadLine();
            split = line.Split(cs);
            ix = split.Count() - 1;
            for (i = 0; i < ix; i++) x[i] = float.Parse(split[i + 1]);
            iy = 0;
            while ((line = sr.ReadLine()) != null)
            {
                split = line.Split(cs, StringSplitOptions.RemoveEmptyEntries);
                y[iy] = float.Parse(split[0]);
                for (i = 0; i < ix; i++)
                {
                    z[i, iy] = float.Parse(split[i + 1]);
                    s = 0.866f * (x[i] + y[iy]);
                    if (s < xm) xm = s;
                    if (xn < s) xn = s;
                    s = 0.5f * (y[iy] - x[i]) + z[i, iy];
                    if (s < ym) ym = s;
                    if (yn < s) yn = s;
                }
                iy++;
            }
            sr.Close();
            if (ix < 2 || iy < 2) return;
            textBox1.Text = openFileDialog1.FileName;
            saveFileDialog1.FileName = Path.GetFileName(openFileDialog1.FileName);
            saveFileDialog1.FileName = saveFileDialog1.FileName.Replace("csv", "3ds");
            if (ix < iy) i = iy;
            else i = ix;
            Point[] pnt = new Point[i];
            Bitmap canvas = new Bitmap(pictureBox1.Width, pictureBox1.Height);
            Graphics g = Graphics.FromImage(canvas);
            xn -= xm;
            yn -= ym;
            xm += xn / 2;
            ym += yn / 2;
            dx = 0.95f * pictureBox1.Width / xn;
            dy = 0.95f * pictureBox1.Height / yn;
            if (dy < dx) s = dy;
            else s = dx;
            xn = pictureBox1.Width / 2;
            yn = pictureBox1.Height / 2;
            for (j = 0; j < iy; j++)
            {
                for (i = 0; i < ix; i++)
                {
                    pnt[i].X = (int)(+(s * (0.866f * (x[i] + y[j]) - xm)) + xn);
                    pnt[i].Y = (int)(-(s * ((0.5 * (y[j] - x[i]) + z[i, j]) - ym)) + yn);
                }
                g.DrawLines(Pens.Black, pnt);
            }
            for (i = 0; i < ix; i++)
            {
                for (j = 0; j < iy; j++)
                {
                    pnt[j].X = (int)(+(s * (0.866f * (x[i] + y[j]) - xm)) + xn);
                    pnt[j].Y = (int)(-(s * ((0.5 * (y[j] - x[i]) + z[i, j]) - ym)) + yn);
                }
                g.DrawLines(Pens.Black, pnt);
            }
            pictureBox1.Image = canvas;
        }

        private void button2_Click(object sender, EventArgs e)
        {
            if (textBox1.Text == "") return;
            saveFileDialog1.ShowDialog();
            textBox2.Text = saveFileDialog1.FileName;
            double s = Math.Pow(10, comboBox2.SelectedIndex);
            if (saveFileDialog1.FilterIndex == 1)
            {
                char[] ob = { 'c', 's', 'v', '2', '3', 'D', 'S', '\0' };
                char[] mt = { 'D', 'e', 'f', 'a', 'u', 'l', 't', 'M', 'a', 't', 'e', 'r', 'i', 'a', 'l', '_', '0', '\0' };
                int i, j;
                ushort pt = (ushort)(ix * iy);                  // ポイント数
                ushort pg = (ushort)((ix - 1) * (iy - 1) * 2);  // ポリゴン数
                short lmt = 102;                                // マテリアル長
                int lpg = (int)(2 + 4 + 2 + 2 * pg * 4);        // ポリゴン長
                int lpt = (int)(2 + 4 + 2 + 4 * pt * 3);        // ポイント長
                int lpm = (int)(2 + 4 + lpt + lpg);             // メッシュ長
                int lob = (int)(2 + 4 + 8 + lpm);               // オブジェクト長
                int lph = (int)(2 + 4 + lob + lmt);             // 全データ長
                int len = (int)(2 + 4 + lph);                   // ファイル長
                FileStream fs = new FileStream(saveFileDialog1.FileName, FileMode.Create);
                BinaryWriter bw = new BinaryWriter(fs);
                bw.Write((ushort)'\x4d4d');
                bw.Write(len);
                bw.Write((ushort)'\x3d3d');
                bw.Write(lph);
                bw.Write((ushort)'\x4000');
                bw.Write(lob);
                bw.Write(ob);
                bw.Write((ushort)'\x4100');
                bw.Write(lpm);
                bw.Write((ushort)'\x4110');
                bw.Write(lpt);
                bw.Write(pt);
                if (comboBox1.SelectedIndex == 1)
                {
                    for (j = 0; j < iy; j++)
                    {
                        y[j] = -y[j];
                        for (i = 0; i < ix; i++)
                        {
                            bw.Write((float)(s * x[i]));
                            bw.Write((float)(s * z[i, j]));
                            bw.Write((float)(s * y[j]));
                        }
                    }
                }
                else
                {
                    for (j = 0; j < iy; j++)
                    {
                        for (i = 0; i < ix; i++)
                        {
                            bw.Write((float)(s * x[i]));
                            bw.Write((float)(s * y[j]));
                            bw.Write((float)(s * z[i, j]));
                        }
                    }
                }
                bw.Write((ushort)'\x4120');
                bw.Write(lpg);
                bw.Write(pg);
                for (j = 0; j < iy - 1; j++)
                {
                    for (i = 0; i < ix - 1; i++)
                    {
                        bw.Write((ushort)(j * ix + i));
                        bw.Write((ushort)(j * ix + i + 1));
                        bw.Write((ushort)((j + 1) * ix + i));
                        bw.Write((ushort)0);
                        bw.Write((ushort)((j + 1) * ix + i + 1));
                        bw.Write((ushort)((j + 1) * ix + i));
                        bw.Write((ushort)(j * ix + i + 1));
                        bw.Write((ushort)0);
                    }
                }
                bw.Write((ushort)'\xafff');
                bw.Write((int)96);
                bw.Write((ushort)'\xa000');
                bw.Write((int)24);
                bw.Write(mt);
                bw.Write((ushort)'\xa010');
                bw.Write((int)24);
                bw.Write((ushort)'\x0010');
                bw.Write((int)18);
                bw.Write((float)0.75);
                bw.Write((float)0.75);
                bw.Write((float)0.75);
                bw.Write((ushort)'\xa020');
                bw.Write((int)24);
                bw.Write((ushort)'\x0010');
                bw.Write((int)18);
                bw.Write((float)0.75);
                bw.Write((float)0.75);
                bw.Write((float)0.75);
                bw.Write((ushort)'\xa030');
                bw.Write((int)24);
                bw.Write((ushort)'\x0010');
                bw.Write((int)18);
                bw.Write((float)0.25);
                bw.Write((float)0.25);
                bw.Write((float)0.25);
                bw.Close();
            }
            else
            {
                int i, j;
                FileStream fs = new FileStream(saveFileDialog1.FileName, FileMode.Create);
                AddText(fs, "  0\nSECTION\n");
                AddText(fs, "  2\nENTITIES\n");
                for (j = 0; j < iy-1; j++)
                {
                    for (i = 0; i < ix - 1; i++)
                    {
                        if (comboBox1.SelectedIndex == 1)
                        {
                            AddText(fs, "  0\n3DFACE\n");
                            AddText(fs, "  8\ncsv2dxf\n");
                            AddText(fs, " 10\n" + s * x[i] + "\n");
                            AddText(fs, " 20\n" + s * z[i, j] + "\n");
                            AddText(fs, " 30\n" + s * y[j] + "\n");
                            AddText(fs, " 11\n" + s * x[i + 1] + "\n");
                            AddText(fs, " 21\n" + s * z[i + 1, j] + "\n");
                            AddText(fs, " 31\n" + s * y[j] + "\n");
                            AddText(fs, " 12\n" + s * x[i] + "\n");
                            AddText(fs, " 22\n" + s * z[i, j + 1] + "\n");
                            AddText(fs, " 32\n" + s * y[j + 1] + "\n");
                            AddText(fs, " 13\n" + s * x[i] + "\n");
                            AddText(fs, " 23\n" + s * z[i, j + 1] + "\n");
                            AddText(fs, " 33\n" + s * y[j + 1] + "\n");
                            AddText(fs, "  0\n3DFACE\n");
                            AddText(fs, "  8\ncsv2dxf\n");
                            AddText(fs, " 10\n" + s * x[i] + "\n");
                            AddText(fs, " 20\n" + s * z[i, j + 1] + "\n");
                            AddText(fs, " 30\n" + s * y[j + 1] + "\n");
                            AddText(fs, " 11\n" + s * x[i + 1] + "\n");
                            AddText(fs, " 21\n" + s * z[i + 1, j] + "\n");
                            AddText(fs, " 31\n" + s * y[j] + "\n");
                            AddText(fs, " 12\n" + s * x[i + 1] + "\n");
                            AddText(fs, " 22\n" + s * z[i + 1, j + 1] + "\n");
                            AddText(fs, " 32\n" + s * y[j + 1] + "\n");
                            AddText(fs, " 13\n" + s * x[i + 1] + "\n");
                            AddText(fs, " 23\n" + s * z[i + 1, j + 1] + "\n");
                            AddText(fs, " 33\n" + s * y[j + 1] + "\n");
                        }
                        else
                        {
                            AddText(fs, "  0\n3DFACE\n");
                            AddText(fs, "  8\ncsv2dxf\n");
                            AddText(fs, " 10\n" + s * x[i] + "\n");
                            AddText(fs, " 20\n" + s * y[j] + "\n");
                            AddText(fs, " 30\n" + s * z[i, j] + "\n");
                            AddText(fs, " 11\n" + s * x[i + 1] + "\n");
                            AddText(fs, " 21\n" + s * y[j] + "\n");
                            AddText(fs, " 31\n" + s * z[i + 1, j] + "\n");
                            AddText(fs, " 12\n" + s * x[i] + "\n");
                            AddText(fs, " 22\n" + s * y[j + 1] + "\n");
                            AddText(fs, " 32\n" + s * z[i, j + 1] + "\n");
                            AddText(fs, " 13\n" + s * x[i] + "\n");
                            AddText(fs, " 23\n" + s * y[j + 1] + "\n");
                            AddText(fs, " 33\n" + s * z[i, j + 1] + "\n");
                            AddText(fs, "  0\n3DFACE\n");
                            AddText(fs, "  8\ncsv2dxf\n");
                            AddText(fs, " 10\n" + s * x[i] + "\n");
                            AddText(fs, " 20\n" + s * y[j + 1] + "\n");
                            AddText(fs, " 30\n" + s * z[i, j + 1] + "\n");
                            AddText(fs, " 11\n" + s * x[i + 1] + "\n");
                            AddText(fs, " 21\n" + s * y[j] + "\n");
                            AddText(fs, " 31\n" + s * z[i + 1, j] + "\n");
                            AddText(fs, " 12\n" + s * x[i + 1] + "\n");
                            AddText(fs, " 22\n" + s * y[j + 1] + "\n");
                            AddText(fs, " 32\n" + s * z[i + 1, j + 1] + "\n");
                            AddText(fs, " 13\n" + s * x[i + 1] + "\n");
                            AddText(fs, " 23\n" + s * y[j + 1] + "\n");
                            AddText(fs, " 33\n" + s * z[i + 1, j + 1] + "\n");
                        }
                    }
                }
                AddText(fs, "  0\nENDSEC\n");
                AddText(fs, "  0\nEOF\n");
                fs.Close();
            }
        }
    }
}
